---
- name: Check mount variable is a dictionary
  ansible.builtin.assert:
    that:
      - mount is not string and mount is mapping

- name: Check necessary dictionary items are defined
  ansible.builtin.assert:
    that: "'{{ item }}' in mount"
  loop:
    - device
    - type
    - path

- name: Create mount point
  ansible.builtin.file:
    path: "{{ mount.path }}"
    state: directory
    mode: '0755'

- name: Construct a filesystem
  community.general.filesystem:
    fstype: "{{ mount.type }}"
    dev: "{{ mount.device }}"

- name: Mount the filesystem
  ansible.posix.mount:
    path: "{{ mount.path }}"
    src: "{{ mount.device }}"
    fstype: "{{ mount.type }}"
    state: mounted
